import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
 
public class LAN_Bridge extends JFrame implements ActionListener {
    
    //Declare variables
    private static final long serialVersionUID = 1L;
    private JPanel p;
    private JButton buttonA;
    private JButton buttonB;
    private JButton buttonC;
    private JButton buttonD;
    private JButton buttonE;
    private JButton buttonF;
    private JButton buttonG;
    private JButton buttonSend;
    private JButton buttonClear;
    private JButton buttonReset;
    private JTextField text;
    private JLabel image;
    private int count = 0;
    
    public static void main(String[] args) {
        new LAN_Bridge().setVisible(true);
    }
        
    //Building the diagram    
    public LAN_Bridge() {
        buttonA = new JButton("A");
        buttonB = new JButton("B");
        buttonC = new JButton("C");
        buttonD = new JButton("D");
        buttonE = new JButton("E");
        buttonF = new JButton("F");
        buttonG = new JButton("G");
        buttonSend = new JButton("Send");
        buttonClear = new JButton("Clear");
        buttonReset = new JButton("Reset");
        image = new JLabel(new ImageIcon("/Users/gerly/Downloads/diagram4b.png"));
        text = new JTextField("");
        
        //Create panel
        p = new JPanel();
        p.setLayout(null);
        
        //Create the window
        add(p);
        setTitle("LAN Bridge");
        setSize(new Dimension(800, 550));
        setLocationRelativeTo(null);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
        
        //Positioning and sizing buttons, image, and text field
        buttonA.setBounds(50, 90, 60, 60);   
        buttonB.setBounds(50, 180, 60, 60);      
        buttonC.setBounds(50, 275, 60, 60);      
        buttonD.setBounds(525, 100, 60, 60);      
        buttonE.setBounds(670, 138, 60, 60);      
        buttonF.setBounds(670, 220, 60, 60);
        buttonG.setBounds(525, 270, 60, 60);
        buttonSend.setBounds(280, 380, 70, 30);
        buttonClear.setBounds(280, 415, 70, 30);
        buttonReset.setBounds(280, 450, 70, 30);
        image.setBounds(40, -120, 700, 700);
        text.setBounds(380, 410, 100, 40);
        text.setHorizontalAlignment(JTextField.CENTER);
        
        //Assign buttons to their functions
        buttonA.addActionListener(this);
        buttonB.addActionListener(this);
        buttonC.addActionListener(this);
        buttonD.addActionListener(this);
        buttonE.addActionListener(this);
        buttonF.addActionListener(this);
        buttonG.addActionListener(this);
        buttonSend.addActionListener(this);
        buttonClear.addActionListener(this);
        buttonReset.addActionListener(this);
        
        //Add buttons, image, and text field to panel
        p.add(buttonA);
        p.add(buttonB);
        p.add(buttonC);
        p.add(buttonD);
        p.add(buttonE);
        p.add(buttonF);
        p.add(buttonG);
        p.add(buttonSend);
        p.add(buttonClear);
        p.add(buttonReset);
        p.add(image);
        p.add(text);
    }
    
    //Adding funtions to the buttons
    @Override
    public void actionPerformed(ActionEvent e) {
        String name = e.getActionCommand();
    
        //Checks which button was clicked on
        switch (name) {
            case "A":   if (buttonA.getBackground() == Color.GREEN || buttonA.getBackground() == Color.ORANGE) {      
                           buttonA.setBackground(null);                    //Buttons A to G will turn back to default color when clicked on if already green or orange                                          
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonA.setBackground(Color.ORANGE);            //Buttons A to G (destination station) will turn orange when clicked on
                           count++;
                        }
                        else {
                           buttonA.setBackground(Color.GREEN);             //Buttons A to G (source station) will turn green when clicked on
                           count++;   
                        } 
                        break;
                        
            case "B":   if (buttonB.getBackground() == Color.GREEN || buttonB.getBackground() == Color.ORANGE) {
                           buttonB.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonB.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonB.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                        
            case "C":   if (buttonC.getBackground() == Color.GREEN || buttonC.getBackground() == Color.ORANGE) {
                           buttonC.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonC.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonC.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                        
            case "D":   if (buttonD.getBackground() == Color.GREEN || buttonD.getBackground() == Color.ORANGE) {
                           buttonD.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonD.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonD.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                        
            case "E":   if (buttonE.getBackground() == Color.GREEN || buttonE.getBackground() == Color.ORANGE) {
                           buttonE.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonE.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonE.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                       
            case "F":   if (buttonF.getBackground() == Color.GREEN  || buttonF.getBackground() == Color.ORANGE) {
                           buttonF.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonF.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonF.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                        
            case "G":   if (buttonG.getBackground() == Color.GREEN || buttonG.getBackground() == Color.ORANGE) {
                           buttonG.setBackground(null);
                           count--;
                        }
                        else if (count % 2 == 1) {
                           buttonG.setBackground(Color.ORANGE); 
                           count++;
                        }
                        else {
                           buttonG.setBackground(Color.GREEN);
                           count++;   
                        } 
                        break;
                        
            //If two buttons/stations are connected to the same port, both will turn back to default color (discards frame)            
            case "Send":   if ((buttonA.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                               (buttonA.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) ||
                               (buttonB.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                               (buttonB.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) ||
                               (buttonC.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                               (buttonC.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                               (buttonD.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                               (buttonD.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) ||
                               (buttonD.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) ||
                               (buttonE.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                               (buttonE.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) ||
                               (buttonE.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) ||
                               (buttonF.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                               (buttonF.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                               (buttonF.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) ||
                               (buttonG.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                               (buttonG.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                               (buttonG.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE)) {
                                    buttonA.setBackground(null);
                                    buttonB.setBackground(null);
                                    buttonC.setBackground(null);
                                    buttonD.setBackground(null);
                                    buttonE.setBackground(null);
                                    buttonF.setBackground(null);
                                    buttonG.setBackground(null);
                                    text.setText("Discarded");
                                    count -= 2;
                           }
            
                           //If the two buttons/stations are from different ports, then all stations will get flooded except the source button/station
                           else if (count == 2) {
                              if ((buttonA.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                                  (buttonA.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                                  (buttonA.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) ||
                                  (buttonA.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE)) {
                                    buttonA.setBackground(Color.RED);
                                    buttonB.setBackground(Color.CYAN);
                                    buttonC.setBackground(Color.CYAN);
                                    buttonD.setBackground(Color.CYAN);
                                    buttonE.setBackground(Color.CYAN);
                                    buttonF.setBackground(Color.CYAN);
                                    buttonG.setBackground(Color.CYAN);                                    
                              }
                              
                              else if ((buttonB.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                                       (buttonB.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                                       (buttonB.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) ||
                                       (buttonB.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.RED);
                                          buttonC.setBackground(Color.CYAN);
                                          buttonD.setBackground(Color.CYAN);
                                          buttonE.setBackground(Color.CYAN);
                                          buttonF.setBackground(Color.CYAN);
                                          buttonG.setBackground(Color.CYAN);                                        
                              }
                              
                              else if ((buttonC.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) ||
                                       (buttonC.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) ||
                                       (buttonC.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) ||
                                       (buttonC.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.CYAN);
                                          buttonC.setBackground(Color.RED);
                                          buttonD.setBackground(Color.CYAN);
                                          buttonE.setBackground(Color.CYAN);
                                          buttonF.setBackground(Color.CYAN);
                                          buttonG.setBackground(Color.CYAN);                                        
                              }
                              
                              else if ((buttonD.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                                       (buttonD.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                                       (buttonD.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.CYAN);
                                          buttonC.setBackground(Color.CYAN);
                                          buttonD.setBackground(Color.RED);
                                          buttonE.setBackground(Color.CYAN);
                                          buttonF.setBackground(Color.CYAN);
                                          buttonG.setBackground(Color.CYAN);                                         
                              }
                              
                              else if ((buttonE.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                                       (buttonE.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                                       (buttonE.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.CYAN);
                                          buttonC.setBackground(Color.CYAN);
                                          buttonD.setBackground(Color.CYAN);
                                          buttonE.setBackground(Color.RED);
                                          buttonF.setBackground(Color.CYAN);
                                          buttonG.setBackground(Color.CYAN);                                         
                              }
                              
                              else if ((buttonF.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                                       (buttonF.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                                       (buttonF.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.CYAN);
                                          buttonC.setBackground(Color.CYAN);
                                          buttonD.setBackground(Color.CYAN);
                                          buttonE.setBackground(Color.CYAN);
                                          buttonF.setBackground(Color.RED);
                                          buttonG.setBackground(Color.CYAN);                                         
                              }
                              
                              else if ((buttonG.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) ||
                                       (buttonG.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) ||
                                       (buttonG.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE)) {
                                          buttonA.setBackground(Color.CYAN);
                                          buttonB.setBackground(Color.CYAN);
                                          buttonC.setBackground(Color.CYAN);
                                          buttonD.setBackground(Color.CYAN);
                                          buttonE.setBackground(Color.CYAN);
                                          buttonF.setBackground(Color.CYAN);
                                          buttonG.setBackground(Color.RED);                                          
                              }
                              text.setText("Flooded");
                           }
                        
                           //After the flood, the two buttons/stations will now connect properly
                           else if (count > 2) {
                              if (buttonA.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) {
                                 buttonA.setBackground(Color.CYAN);
                                 buttonD.setBackground(Color.CYAN);
                              }
                              else if (buttonA.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) {
                                 buttonA.setBackground(Color.CYAN);
                                 buttonE.setBackground(Color.CYAN);
                              }
                              else if (buttonA.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) {
                                 buttonA.setBackground(Color.CYAN);
                                 buttonF.setBackground(Color.CYAN);
                              }
                              else if (buttonA.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) {
                                 buttonA.setBackground(Color.CYAN);
                                 buttonG.setBackground(Color.CYAN);
                              }
                              else if (buttonB.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) {
                                 buttonB.setBackground(Color.CYAN);
                                 buttonD.setBackground(Color.CYAN);
                              }
                              else if (buttonB.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) {
                                 buttonB.setBackground(Color.CYAN);
                                 buttonE.setBackground(Color.CYAN);
                              }
                              else if (buttonB.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) {
                                 buttonB.setBackground(Color.CYAN);
                                 buttonF.setBackground(Color.CYAN);
                              }
                              else if (buttonB.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) {
                                 buttonB.setBackground(Color.CYAN);
                                 buttonG.setBackground(Color.CYAN);
                              }
                              else if (buttonC.getBackground() == Color.GREEN && buttonD.getBackground() == Color.ORANGE) {
                                 buttonC.setBackground(Color.CYAN);
                                 buttonD.setBackground(Color.CYAN);
                              }
                              else if (buttonC.getBackground() == Color.GREEN && buttonE.getBackground() == Color.ORANGE) {
                                 buttonC.setBackground(Color.CYAN);
                                 buttonE.setBackground(Color.CYAN);
                              }
                              else if (buttonC.getBackground() == Color.GREEN && buttonF.getBackground() == Color.ORANGE) {
                                 buttonC.setBackground(Color.CYAN);
                                 buttonF.setBackground(Color.CYAN);
                              }
                              else if (buttonC.getBackground() == Color.GREEN && buttonG.getBackground() == Color.ORANGE) {
                                 buttonC.setBackground(Color.CYAN);
                                 buttonG.setBackground(Color.CYAN);
                              }
                              else if (buttonD.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) {
                                 buttonD.setBackground(Color.CYAN);
                                 buttonA.setBackground(Color.CYAN);
                              }
                              else if (buttonD.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) {
                                 buttonD.setBackground(Color.CYAN);
                                 buttonB.setBackground(Color.CYAN);
                              }
                              else if (buttonD.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) {
                                 buttonD.setBackground(Color.CYAN);
                                 buttonC.setBackground(Color.CYAN);
                              }
                              else if (buttonE.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) {
                                 buttonE.setBackground(Color.CYAN);
                                 buttonA.setBackground(Color.CYAN);
                              }
                              else if (buttonE.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) {
                                 buttonE.setBackground(Color.CYAN);
                                 buttonB.setBackground(Color.CYAN);
                              }
                              else if (buttonE.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) {
                                 buttonE.setBackground(Color.CYAN);
                                 buttonC.setBackground(Color.CYAN);
                              }
                              else if (buttonF.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) {
                                 buttonF.setBackground(Color.CYAN);
                                 buttonA.setBackground(Color.CYAN);
                              }
                              else if (buttonF.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) {
                                 buttonF.setBackground(Color.CYAN);
                                 buttonB.setBackground(Color.CYAN);
                              }
                              else if (buttonF.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) {
                                 buttonF.setBackground(Color.CYAN);
                                 buttonC.setBackground(Color.CYAN);
                              }
                              else if (buttonG.getBackground() == Color.GREEN && buttonA.getBackground() == Color.ORANGE) {
                                 buttonG.setBackground(Color.CYAN);
                                 buttonA.setBackground(Color.CYAN);
                              }
                              else if (buttonG.getBackground() == Color.GREEN && buttonB.getBackground() == Color.ORANGE) {
                                 buttonG.setBackground(Color.CYAN);
                                 buttonB.setBackground(Color.CYAN);
                              }
                              else if (buttonG.getBackground() == Color.GREEN && buttonC.getBackground() == Color.ORANGE) {
                                 buttonG.setBackground(Color.CYAN);
                                 buttonC.setBackground(Color.CYAN);
                              }
                              text.setText("Connected");
                           }
                           break;
            
            //Clears the colors without resetting to before the flood          
            case "Clear":  buttonA.setBackground(null);
                           buttonB.setBackground(null);
                           buttonC.setBackground(null);
                           buttonD.setBackground(null);
                           buttonE.setBackground(null);
                           buttonF.setBackground(null);
                           buttonG.setBackground(null);
                           text.setText("Cleared");
                           break;
                           
            //Clears the colors and resets to before the flood                    
            default:    buttonA.setBackground(null);
                        buttonB.setBackground(null);
                        buttonC.setBackground(null);
                        buttonD.setBackground(null);
                        buttonE.setBackground(null);
                        buttonF.setBackground(null);
                        buttonG.setBackground(null);
                        text.setText("Reset");
                        count = 0;  
                        break;
        }
    }
}